
// MFC_TSPLDlg.cpp : 实现文件
//

#include "stdafx.h"
#include "MFC_TSPL.h"
#include "MFC_TSPLDlg.h"
#include "afxdialogex.h"
#include "tspl_printer_base.h"
#include "tspl_box.h"
#include "barcode.h"
#include "printertext.h"
#include "bitmap.h"
#include "qrcode.h"
#include "direction.h"
#include "dmatrix.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// 对话框数据
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CMFC_TSPLDlg 对话框



CMFC_TSPLDlg::CMFC_TSPLDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMFC_TSPLDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFC_TSPLDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);

}

BEGIN_MESSAGE_MAP(CMFC_TSPLDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CMFC_TSPLDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON1, &CMFC_TSPLDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON3, &CMFC_TSPLDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMFC_TSPLDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON7, &CMFC_TSPLDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON2, &CMFC_TSPLDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON6, &CMFC_TSPLDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON5, &CMFC_TSPLDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON8, &CMFC_TSPLDlg::OnBnClickedButton8)
	ON_BN_CLICKED(IDCANCEL, &CMFC_TSPLDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON9, &CMFC_TSPLDlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, &CMFC_TSPLDlg::OnBnClickedButton10)
END_MESSAGE_MAP()


// CMFC_TSPLDlg 消息处理程序

BOOL CMFC_TSPLDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。  当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO:  在此添加额外的初始化代码

	CEdit *txtname = (CEdit*)GetDlgItem(IDC_EDIT1);
	txtname->SetWindowText(_T("HT130"));
	CComboBox *port = (CComboBox*)GetDlgItem(IDC_COMBO1);
	port->AddString(_T("USB"));
	port->AddString(_T("NET"));
	port->SetCurSel(0);
	port->SetWindowText(_T("USB"));
	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CMFC_TSPLDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。  对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CMFC_TSPLDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CMFC_TSPLDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

CString GetFormatError(int Result)
{
	int langid = 1;
	char temp[1024];
	CString str;
	DemFormatError(Result, langid, temp, 0, 1024);
	str.Format(_T("%s"), CStringW( temp));
	return str;
}



//Connection
void CMFC_TSPLDlg::OnBnClickedOk()
{
	UpdateData(TRUE);
	CString name;
	CString port;
	CString strError;

	int status = -1;
		
	int result = -1;
	GetDlgItemText(IDC_EDIT1, name);
	GetDlgItemText(IDC_COMBO1, port);



	if (E_SUCCESS != (result = DemPrinterCreator(&hprinter, cstringtocharstring(name))))
	{
		strError = GetFormatError(result);
		hprinter = NULL;
		AfxMessageBox(strError);
		return;
	}
	if (E_SUCCESS != (result = DemPortOpen(hprinter, cstringtocharstring(port))))
	{
		strError = GetFormatError(result);
		AfxMessageBox(strError);
		return;
	}
	result = DemStatus(hprinter, &status);

	SetDlgItemText(IDC_EDIT3, name + port);
}


//自检
void CMFC_TSPLDlg::OnBnClickedButton1()
{
	DemSelfTest(hprinter);
}
//走纸
void CMFC_TSPLDlg::OnBnClickedButton7()
{
	// TODO:  在此添加控件通知处理程序代码
	DemFormFeed(hprinter);
}
//画框
void CMFC_TSPLDlg::OnBnClickedButton3()
{
	// TODO:  在此添加控件通知处理程序代码
	INT_PTR nRres;
	tspl_box tsplbox;
	nRres = tsplbox.DoModal();
	if (IDCANCEL == nRres) return;
	UpdateData(TRUE);
}
//打印条形码
void CMFC_TSPLDlg::OnBnClickedButton4()
{
	// TODO:  在此添加控件通知处理程序代码
	INT_PTR nRres;
	barcode tsplbarcode;
	nRres = tsplbarcode.DoModal();
	if (IDCANCEL == nRres) return;
	UpdateData(TRUE);
}




void CMFC_TSPLDlg::OnBnClickedButton2()
{
	// TODO:  在此添加控件通知处理程序代码
	INT_PTR nRres;
	printertext tspltxt;
	nRres = tspltxt.DoModal();
	if (IDCANCEL == nRres) return;
	UpdateData(TRUE);
	
}


void CMFC_TSPLDlg::OnBnClickedButton6()
{
	// TODO:  在此添加控件通知处理程序代码
	INT_PTR nRres;
	bitmap bit;
	nRres = bit.DoModal();
	if (IDCANCEL == nRres) return;
	UpdateData(TRUE);
}


void CMFC_TSPLDlg::OnBnClickedButton5()
{
	// TODO:  在此添加控件通知处理程序代码
	INT_PTR nRres;
	qrcode qr_code;
	nRres = qr_code.DoModal();
	if (IDCANCEL == nRres) return;
	UpdateData(TRUE);
}


void CMFC_TSPLDlg::OnBnClickedButton8()
{
	// TODO:  在此添加控件通知处理程序代码
	INT_PTR nRres;
	direction DDire;
	nRres = DDire.DoModal();
	if (IDCANCEL == nRres) return;
	UpdateData(TRUE);
}


void CMFC_TSPLDlg::OnBnClickedCancel()
{
	// TODO:  在此添加控件通知处理程序代码
	DemPortClose(hprinter);
	DemPrinterDestroy(hprinter);
	SetDlgItemText(IDC_EDIT3, _T(""));
	
}


void CMFC_TSPLDlg::OnBnClickedButton9()
{
	// TODO:  在此添加控件通知处理程序代码
	CDialogEx::OnCancel();
}

//打印Dmatrix码
void CMFC_TSPLDlg::OnBnClickedButton10()
{
	// TODO: 在此添加控件通知处理程序代码
	INT_PTR nRres;
	dmatrix dmatrix;
	nRres = dmatrix.DoModal();
	if (IDCANCEL == nRres) return;
	UpdateData(TRUE);
}



